"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _reactBootstrap = require("react-bootstrap");

var _atpDnd = require("atp-dnd");

var _reactFontAwesome = require("react-font-awesome-5");

var _atpUi = require("atp-ui");

var _treeNode = require("../container/tree-node");

var _treeNode2 = _interopRequireDefault(_treeNode);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var DropTargetDiv = function DropTargetDiv(_ref) {
    var style = _ref.style;
    return _react2.default.createElement(
        "div",
        { style: style || {} },
        _react2.default.createElement(
            _atpDnd.Active,
            null,
            _react2.default.createElement(
                _atpDnd.CanDrop,
                null,
                _react2.default.createElement("div", { style: { height: "16px", border: "dashed 1px" } })
            ),
            _react2.default.createElement(
                _atpDnd.CannotDrop,
                null,
                _react2.default.createElement("div", { style: { height: "16px", border: "dashed 1px red" } })
            )
        ),
        _react2.default.createElement(
            _atpDnd.Inactive,
            null,
            _react2.default.createElement("div", { style: { height: "4px", border: "none" } })
        )
    );
};

exports.default = function (props) {
    return _react2.default.createElement(
        "li",
        { className: props.nodeId },
        _react2.default.createElement(
            _reactBootstrap.Row,
            null,
            _react2.default.createElement(
                _reactBootstrap.Col,
                { xs: 8 },
                _react2.default.createElement(
                    "div",
                    { style: { textIndent: "-18px", marginLeft: "18px" } },
                    props.children.length > 0 && props.node.open && _react2.default.createElement(_reactFontAwesome.Icon.CaretDown, { fixedWidth: true, size: "lg", onClick: props.onClose(props.nodeId) }),
                    props.children.length > 0 && !props.node.open && _react2.default.createElement(_reactFontAwesome.Icon.CaretRight, { fixedWidth: true, size: "lg", onClick: props.onOpen(props.nodeId) }),
                    props.canDrag && _react2.default.createElement(
                        _atpDnd.Draggable,
                        {
                            type: props.draggable || "tree-node",
                            id: props.id,
                            style: {
                                marginLeft: props.children.length === 0 ? "40px" : "20px",
                                display: 'inline-block'
                            }
                        },
                        _react2.default.createElement(
                            _atpDnd.DropTarget,
                            {
                                action: "into",
                                accepts: props.accepts,
                                id: props.getId(props.obj),
                                onReceiveDrop: props.onReceiveDrop
                            },
                            _react2.default.createElement(
                                "span",
                                {
                                    onClick: function onClick() {
                                        return props.onClick(props.getId(props.obj));
                                    },
                                    style: { marginLeft: "-4px" }
                                },
                                props.obj && props.getContent(props.obj, props.isSelected(props.obj))
                            )
                        )
                    ),
                    props.canDrag && _react2.default.createElement(
                        _atpDnd.DropTarget,
                        {
                            action: "into",
                            accepts: props.accepts,
                            id: props.getId(props.obj),
                            onReceiveDrop: props.onReceiveDrop
                        },
                        _react2.default.createElement(DropTargetDiv, { style: { marginLeft: "20px", width: "100%" } })
                    ),
                    !props.canDrag && _react2.default.createElement(
                        "span",
                        {
                            onClick: function onClick() {
                                return props.onClick(props.getId(props.obj));
                            },
                            style: { marginLeft: "-4px" }
                        },
                        props.obj && props.getContent(props.obj, props.isSelected(props.obj))
                    )
                )
            ),
            _react2.default.createElement(
                _reactBootstrap.Col,
                { xs: 4, className: "text-right" },
                props.canCreate && _react2.default.createElement(
                    _reactBootstrap.Button,
                    {
                        bsSize: "xsmall",
                        bsStyle: "link",
                        className: "text-success",
                        onClick: function onClick() {
                            props.onAddChild(props.getId(props.obj));
                            props.onOpen(props.nodeId)();
                        }
                    },
                    _react2.default.createElement(_reactFontAwesome.Icon.Plus, { fixedWidth: true })
                ),
                props.canDelete && _react2.default.createElement(_atpUi.DeleteButton, {
                    id: "treeNodeDeleteBtn" + props.getId(props.obj),
                    onClick: function onClick() {
                        return props.onDelete(props.getId(props.obj));
                    }
                })
            )
        ),
        _react2.default.createElement(
            "ul",
            { style: {
                    paddingLeft: "20px",
                    marginTop: "4px",
                    listStyleType: "none",
                    display: props.node.open ? "block" : "none"
                } },
            props.children && props.children.map(function (obj) {
                return _react2.default.createElement(_treeNode2.default, _extends({}, props, {
                    parentNodeId: props.nodeId,
                    parents: props.parents.concat(props.getId(props.obj)),
                    key: props.getId(obj),
                    id: props.getId(obj)
                }));
            })
        ),
        _react2.default.createElement(
            _reactBootstrap.Row,
            null,
            _react2.default.createElement(
                _reactBootstrap.Col,
                { xs: 12 },
                _react2.default.createElement(
                    _atpDnd.DropTarget,
                    {
                        action: "after",
                        accepts: props.accepts,
                        id: props.getId(props.obj),
                        onReceiveDrop: props.onReceiveDrop
                    },
                    _react2.default.createElement(DropTargetDiv, { style: { textIndent: "-18px", marginLeft: "18px", width: "calc(100% - 18px)" } })
                )
            )
        )
    );
};