"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.closeAllTreeNodes = exports.closeTreeNode = exports.openAllTreeNodes = exports.openTreeNode = exports.initTreeNode = exports.getTreeNode = exports.TREE_NODE_MOVE = exports.TREE_NODE_CLOSE_ALL = exports.TREE_NODE_CLOSE = exports.TREE_NODE_OPEN_ALL = exports.TREE_NODE_OPEN = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _atpSugar = require("atp-sugar");

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

//Action Types
var TREE_NODE_OPEN = exports.TREE_NODE_OPEN = "atp-tree/node/open";
var TREE_NODE_OPEN_ALL = exports.TREE_NODE_OPEN_ALL = "atp-tree/node/openAll";
var TREE_NODE_CLOSE = exports.TREE_NODE_CLOSE = "atp-tree/node/close";
var TREE_NODE_CLOSE_ALL = exports.TREE_NODE_CLOSE_ALL = "atp-tree/node/closeAll";
var TREE_NODE_MOVE = exports.TREE_NODE_MOVE = "atp-tree/node/move";

//Selectors
var getTreeNode = exports.getTreeNode = function getTreeNode(getState, nodeId) {
    return typeof getState().atpTree !== 'undefined' && typeof getState().atpTree[nodeId] !== 'undefined' ? getState().atpTree[nodeId] : { open: false };
};

//Action creators
var initTreeNode = exports.initTreeNode = function initTreeNode(nodeId) {
    return { type: TREE_NODE_INIT, nodeId: nodeId };
};
var openTreeNode = exports.openTreeNode = function openTreeNode(nodeId) {
    return { type: TREE_NODE_OPEN, nodeId: nodeId };
};
var openAllTreeNodes = exports.openAllTreeNodes = function openAllTreeNodes(nodePrefix) {
    return { type: TREE_NODE_OPEN_ALL, nodePrefix: nodePrefix };
};
var closeTreeNode = exports.closeTreeNode = function closeTreeNode(nodeId) {
    return { type: TREE_NODE_CLOSE, nodeId: nodeId };
};
var closeAllTreeNodes = exports.closeAllTreeNodes = function closeAllTreeNodes(nodePrefix) {
    return { type: TREE_NODE_CLOSE_ALL, nodePrefix: nodePrefix };
};

var toggleOpenStatus = function toggleOpenStatus(state, id, status) {
    return _extends({}, state, _defineProperty({}, id, _extends({}, state[id], {
        open: status
    })));
};

var toggleAllOpenStatus = function toggleAllOpenStatus(state, prefix, status) {
    return (0, _atpSugar.o)(state).map(function (node, nodeId) {
        return _extends({}, node, {
            open: nodeId.indexOf(prefix) === 0 ? status : node.open
        });
    }).raw;
};

//Reducer

exports.default = function () {
    var _o$switch;

    var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
    var action = arguments[1];
    return (0, _atpSugar.o)(action.type).switch((_o$switch = {}, _defineProperty(_o$switch, TREE_NODE_OPEN, function () {
        return toggleOpenStatus(state, action.nodeId, true);
    }), _defineProperty(_o$switch, TREE_NODE_CLOSE, function () {
        return toggleOpenStatus(state, action.nodeId, false);
    }), _defineProperty(_o$switch, TREE_NODE_OPEN_ALL, function () {
        return toggleAllOpenStatus(state, action.nodePrefix, true);
    }), _defineProperty(_o$switch, TREE_NODE_CLOSE_ALL, function () {
        return toggleAllOpenStatus(state, action.nodePrefix, false);
    }), _defineProperty(_o$switch, TREE_NODE_MOVE, function () {
        return state;
    }), _defineProperty(_o$switch, "default", function _default() {
        return state;
    }), _o$switch));
};