"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

//Ancestry
var parent = exports.parent = function parent(node) {
    return node.parent;
};
var ancestors = exports.ancestors = function ancestors(node) {
    return node.parent ? [node.parent].concat(ancestors(node.parent)) : [];
};
var hierarchy = exports.hierarchy = function hierarchy(node) {
    return [node].concat(ancestors(node));
};
var root = exports.root = function root(node) {
    return node.parent ? root(node.parent) : node;
};

//Checks
var inSubTree = exports.inSubTree = function inSubTree(root, node) {
    return hierarchy(node).contains(root);
};